# @(#)library.mk	1.17 95/10/30
#
# Makefile rules for building libraries
#

default : $(LIBRARY)

!include make.rules

#
# Build library dll
#

$(LIBRARY) : .INIT classes classheaders $(BINDIR)\$(LIBRARY)$G.dll

$(BINDIR)\$(LIBRARY)$G.dll : $(LIBRARY)$G.dll
	copy $? $@

$(LIBRARY)$G.dll : $(LIBRARY).lcf
	$(LINK) -dll -out:$@ $(LFLAGS) @$(LIBRARY).lcf $(JAVALIB) $(LIBS)

$(LIBRARY).lcf : $(FILES_obj) $(OBJ)\libstubs.obj $(RESFILE)
	@echo Created <<$@
$**
<<KEEP

#
# Build library class files and headers
#

!include classes.mk

classes : $(FILES_class)

classheaders : $(CLASSHEADERS)\make.time

$(CLASSHEADERS)\make.time : $(FILES_class) $(JAVAH)
	$(JAVAH) -classpath $(CLASSES) -d $(CLASSHEADERS) $(EXPORTED_CLASSES)
	@echo >$@

libstubs.c : $(FILES_class) $(JAVAH)
	$(JAVAH) -classpath $(CLASSES) -o $@ -stubs $(EXPORTED_CLASSES)

#
# Default rules
#

{$(WIN32_SRC)\$(LIBRARY)}.c{$(OBJ)}.obj :
	$(CC) $(CFLAGS) -I$(WIN32_SRC)\$(LIBRARY) \
			-I$(SHARE_SRC)\$(LIBRARY) -c -Fo$@ $<

{$(SHARE_SRC)\$(LIBRARY)}.c{$(OBJ)}.obj :
	$(CC) $(CFLAGS) -I$(WIN32_SRC)\$(LIBRARY) \
			-I$(SHARE_SRC)\$(LIBRARY) -c -Fo$@ $<

#
# Directory setup and cleanup
#

.INIT :: $(BINDIR) $(CLASSES) $(CLASSHEADERS)

clobber :: FORCE
	-$(DEL) $(BINDIR)\$(LIBRARY)$G.dll

clean :: FORCE
	-$(DEL) libstubs.c $(LIBRARY)$G.lcf
	-$(DELTREE) $(CLASSHEADERS)
