# @(#)program.mk	1.22 95/10/25
#
# Makefile rules for building applications
#

!ifndef MAIN
MAIN = $(WIN32_SRC)\bin\java.c
!endif

!ifdef ICONFILE
RESFILE = $(PROGRAM).res
!endif

default : $(PROGRAM)

!include make.rules

#
# Build program
#

$(PROGRAM) : .INIT classes $(BINDIR)\$(PROGRAM)$G.exe

$(BINDIR)\$(PROGRAM)$G.exe : $(PROGRAM)$G.exe
	copy $? $@

$(PROGRAM)$G.exe : $(PROGRAM)$G.lcf
	$(LINK) -out:$@ $(LFLAGS) @$(PROGRAM)$G.lcf $(JAVALIB) $(LIBS)

$(PROGRAM)$G.lcf : $(FILES_obj) $(OBJ)\$(PROGRAM).obj $(RESFILE)
	@echo Created <<$@
$**
setargv.obj
<<KEEP

$(OBJ)\$(PROGRAM).obj : $(MAIN)
!ifdef JAVA_ARGS
	$(CC) $(CFLAGS) -DJAVA_ARGS=$(JAVA_ARGS) -c -Fo$@ $(MAIN)
!else
	$(CC) $(CFLAGS) -c -Fo$@ $(MAIN)
!endif

$(PROGRAM).res : $(PROGRAM).rc $(PROGRAM).ico
	$(RC) $(PROGRAM).rc

$(PROGRAM).rc :
	echo $(PROGRAM) ICON DISCARDABLE "$(PROGRAM).ico" >$@

$(PROGRAM).ico : $(ICONFILE)
	copy $? $@

#
# Build library class files and headers
#

!include classes.mk

classes : $(FILES_class)

#
# Directory setup and cleanup
#

.INIT :: $(BINDIR) $(CLASSES)

clobber :: FORCE
	-$(DEL) $(BINDIR)\$(PROGRAM)$G.exe

clean :: FORCE
	-$(DEL) $(PROGRAM).rc $(PROGRAM).ico $(PROGRAM)$G.lcf
