/* Copyright (C) SGS-THOMSON Microelectronics Ltd, 1996 */

/*
 * NO-OS implementation of Java threads
 */

#ifndef _BLUE_THREADS_MD_H_
#define _BLUE_THREADS_MD_H_

#include "bool.h"
#include <process.h>
#include <channel.h>

/* from win32 threads_md.h */

#define N_TRACED_REGS 6

/* macro to determine address of structure, given field and field address */

#define OBJECT_ADDR(type,field,field_addr)\
        ((type*)((char*)(field_addr)-(char*)&(((type*)0)->field)))

typedef enum {
    RUNNABLE,
    SUSPENDED,
    SLEEPING,
    MONITOR_WAIT,
    CONDVAR_WAIT
} thread_state_t;

/*
 * Machine dependent thread data structure
 */
typedef struct sys_thread {
    void *cookie;                   /* Back-pointer to shared thread struct */
    Process proc;                   /* ST20 process structure */
    thread_state_t state;           /* Current thread state */
    bool_t system_thread;           /* TRUE if this is a system thread */
    struct sys_thread *next;        /* Next thread in active thread queue */
    void *(*start_proc)(void *);    /* Thread start routine address */
    void *start_parm;               /* parameters */
    int priority;                   /* system mapped priority (HIGH / LOW) */
    int monitor_level;              /* monitor depth */
    int id;                         /* thread id */
    Channel waitchan;               /* for MonitorWait */
    sys_thread_t *next_waiting_thread;
};

extern bool_t ThreadsInitialized;

#endif /* !_BLUE_THREADS_MD_H_ */

