/* fd_md.c */
/* Copyright (C) SGS-THOMSON Microelectronics Ltd, 1996 */

/*
 *  Modified for ST20 by Nigel Atkinson, July 1996
 */

#include "java_io_FileDescriptor.h"
#include <stdio.h>
#include "io_md.h"
#include <iocntrl.h>

void sysInitFD(Classjava_io_FileDescriptor *fdptr, int desc)
{
  fdptr->fd = desc+1;
}

int sysOpenFD(Classjava_io_FileDescriptor *fdobj, const char *path, int oflag, int mode)
{
  int fd = sysOpen((char *)path, oflag);

  mode = mode; /* unused by sysOpen */

  if (fd == -1) return fd;
  fdobj->fd = fd+1;
  return (int)fdobj->fd;
}

int sysCloseFD(Classjava_io_FileDescriptor *fdobj)
{
  if (fdobj->fd-1 >= 0) {
    close((int)(fdobj->fd-1));
    fdobj->fd = -1;
  }
  return 0;
}

int sysReadFD(Classjava_io_FileDescriptor *fdobj, char *buf, int flags)
{
  return read((int)(fdobj->fd-1), buf, flags);
}

int sysWriteFD(Classjava_io_FileDescriptor *fdobj, char *buf, int flags)
{
  return write((int)(fdobj->fd-1), buf, flags);
}

int sysAvailableFD(Classjava_io_FileDescriptor *fdobj, long *pbytes)
{
  int fd = fdobj->fd-1;
  return sysAvailable(fd, pbytes);
}

long sysLseekFD(Classjava_io_FileDescriptor *fdobj, long offset, long whence)
{
  return lseek(fdobj->fd-1, offset, whence);
}
