#ifndef _EXTLIBH
#define _EXTLIBH

/*{{{  operation and rounding codes */
#define Truncate 0 /* Conversion mode to round to zero */
#define Nearest  1 /* Conversion mode to round to nearest */

#define OpMask  3 /* Extract Rounding Mode and Operation from RMOp */
#define RMShift 2

#define Op_Add 0 /* Operation code for addition */
#define Op_Sub 1 /* Operation code for subtraction */
#define Op_Mul 2 /* Operation code for multiplication */
#define Op_Div 3 /* Operation code for division */
#define Op_Rem 4 /* Operation code for remainder, integers only */

#define RN 0 /* Round to nearest */
#define RZ 1 /* Round to zero */
#define RP 2 /* Round to +infinity */
#define RM 3 /* Round to -infinity */
/*}}}*/

/*{{{  IEEE floating point constants */
/*{{{  IEEE single length values */
#define RealShift     8
#define BitsInFrac    24
#define RealExpSh     23

#define RealExp       0X000000FF
#define RealXcess     0X0000007F
#define RealRBit      0X00000080
#define BiggestFinite 0X7F7FFFFF

#define RealInf       0X7F800000
#define RealNaN       0X7F800001

#define REAL32MININT32 0XCF000000
#define REAL32MININT64 0XDF000000
/*}}}*/

/*{{{  IEEE double length values */
#define DRealShift       11
#define DBitsInFrac      53
#define DRealExpSh       20

#define DRealExp         0X000007FF
#define DRealXcess       0X000003FF
#define DRealRBit        0X00000400
#define DBiggestFiniteLo 0XFFFFFFFF
#define DBiggestFiniteHi 0X7FEFFFFF

#define DRealInf         0X7FF00000
#define DRealNaNLo       0X00000001
#define DRealNaNHi       DRealInf

#define REAL64MININT32Hi 0XC1E00000
#define REAL64MININT64Hi 0XC2E00000
/*}}}*/

/*{{{  IEEE NaNs for 32 bit reals */
#define ZeroZeroDivNaN  0X7FC00000
#define InfInfDivNaN    0X7FA00000
#define ZeroInfMulNaN   0X7F900000
#define AddSubInfInfNaN 0X7F880000
#define NegSqrtNaN      0X7F840000
#define RemInfNaN       0X7F804000
#define RemZeroNaN      0X7F802000

#define Real64to32NaN     0X7F820000
#define Real64to32NaNfrac 0X02000000
/*}}}*/

/*{{{  IEEE NaNs for 64 bit reals */
#define DZeroZeroDivNaN  0X7FF80000
#define DInfInfDivNaN    0X7FF40000
#define DZeroInfMulNaN   0X7FF20000
#define DAddSubInfInfNaN 0X7FF10000
#define DNegSqrtNaN      0X7FF08000
#define DRemInfNaN       0X7FF00800
#define DRemZeroNaN      0X7FF00400

#define DReal64to32NaN   0X7FF04000
/*}}}*/
/*}}}*/

#endif /* !_EXTLIBH */
