/*{{{  Header*/
/* machine dependent io routines for cm10 */

/*
 * @(#)io_md.c  1.13 95/11/16
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/* Copyright (C) SGS-THOMSON Microelectronics Ltd, 1996 */

/*
 *  Modified for ST20 by Nigel Atkinson, July 1996
 */
/*}}}  */

/*{{{  Includes*/
#include <errno.h>
#include <string.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include "cm10misc.h"
#include "path_md.h"
#include "io_md.h"
#include "sys_api.h"
#include "stat_fix.h"
/*}}}  */

#define IO_EXCEPTION "java/io/IOException"

/*{{{  sysAccess(const char *path, int mode)*/
int
sysAccess(const char *path, int mode)
{
    char pathbuf[MAX_PATH];

    if (strlen(path) > MAX_PATH - 1) {
	/*errno = ENAMETOOLONG;*/
	return -1;
    }
/*
    return access(sysNativePath(strcpy(pathbuf, path)), mode);
*/
  printf ("sysAccess() called\n");
  return 0;
}
/*}}}  */

/*{{{  sysAvailable(int fd, long *pbytes)*/
int
sysAvailable(int fd, long *pbytes)
{
    long cur, end;

    if ((cur = lseek(fd, 0L, SEEK_CUR)) == -1) {
	return FALSE;
    } else if ((end = lseek(fd, 0L, SEEK_END)) == -1) {
	return FALSE;
    } else if (lseek(fd, cur, SEEK_SET) == -1) {
	return FALSE;
    }
    *pbytes = end - cur;
    return TRUE;
}
/*}}}  */
/*{{{  CloseDir*/
int             sysCloseDir(DIR *dir)
{
  printf("sysCloseDir called\n");
  return 0;
}
/*}}}  */
/*{{{  OpenDir*/
DIR *           sysOpenDir(const char * filename)
{
  printf("sysOpenDir called\n");
  return NULL;

}
/*}}}  */
/*{{{  ReadDir*/
struct dirent * sysReadDir(DIR *dir)
{
  printf("sysReadDir called\n");
  return NULL;
}
/*}}}  */

