/* $Id$ */

/* Copyright (C) SGS-THOMSON Microelectronics Ltd 1996 */

/* derived from extlib */

#include "compint.h"

double r32tor64(float fx)
{
  BOOL Error;
  BIT32 Xfrac, X;
  INT32 Yexp, Yfrac[2], Xexp, Places, Carry;
  double_convert_t res;

  X = ((float_convert_t *)&fx)->__i;

  Error = FALSE;
  
  SHIFTLEFT((BIT32 *) &Xexp, &Xfrac, 0, X << 1, (BIT32) RealShift);
  
  Xfrac = Xfrac >> 1;
  
  if (Xexp != RealExp)
  {
    if ((Xexp != 0))
    {
      Yfrac[1] = Xfrac | SignBit32;
      Yexp = Xexp + (DRealXcess - RealXcess);
    }
    else if ((Xexp | Xfrac) == 0)
    {
      Yfrac[1] = 0;
      Yexp  = 0;
    }
    else
    {
      NORMALISE((BIT32 *) &Places, (BIT32 *) &Yfrac[1], (BIT32 *) &Yfrac[0], Xfrac, 0);
      
      Yexp = ((DRealXcess - RealXcess) + (1 - Places));
    }
  }
  else
  {
    Yexp = DRealExp;
    Yfrac[1] = Xfrac;
    
    Error = TRUE;
  }
  
  SHIFTRIGHT((BIT32 *) &Yfrac[1], (BIT32 *) &Yfrac[0], Yfrac[1] & (~SignBit32), 0, (BIT32) DRealShift);
  SHIFTRIGHT((BIT32 *) &Carry, (BIT32 *) &Yexp, Yexp, 0, (BIT32) (DRealShift + 1));
  
  Yfrac[1] = Yfrac[1] | Yexp;
  
  /* Here we should check Error and maybe raise a trap? */

  res.__i[1] = (Yfrac[1] | (X & SignBit32));
  res.__i[0] = Yfrac[0];

  return res.__d;
}   
