/*
 * @(#)iomgr.h	1.11 95/11/29  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/*
 * Very simple IO manager interface.  This needs to get fixed in
 * a big way.
 */

#ifndef _GREEN_IOMGR_H_
#define _GREEN_IOMGR_H_

#include "monitor.h"

int nonblock_io(int,int);
int write_nonblock(int);

/*
 *  nonblock_io takea a boolean value as its second argument.  When that
 *  boolean is true, the filedescriptor operates in non-blocking mode.
 */
#define IO_DONTBLOCK    1
#define IO_BLOCK        0

extern sys_mon_t _io_lock;
extern int *fd_ref;
extern char *fd_flags;
extern sys_mon_t **fdmon;

#define IO_LOCK_INIT() monitorRegister(&_io_lock, "Monitor IO lock");
#define IO_LOCK()      sysMonitorEnter(&_io_lock)
#define IO_UNLOCK()    sysMonitorExit(&_io_lock)
#define IO_LOCKED()    sysMonitorEntered(&_io_lock)

#define FD_NBINIT       0x1
#define FD_CLOSED       0x2

#define READ_TIMEOUT TIMEOUT_INFINITY
#define WRITE_TIMEOUT TIMEOUT_INFINITY

#define	check_single_fd(fd)		    \
    if ((fd_flags[fd] & FD_NBINIT) == 0) {    \
	nonblock_io(fd, IO_DONTBLOCK);	    \
    }

#define closed_fd(fd) \
    ((fd_flags[fd] & FD_CLOSED) != 0)


typedef int (*sysfunc_t)();

typedef struct syscall {
    char *sym;
    sysfunc_t addr;
} syscall_t;

extern syscall_t systable[];

#define SYS_WRITE   0
#define SYS_WRITEV  1
#define SYS_READ    2
#define SYS_READV   3
#define SYS_GETMSG  4
#define SYS_PUTMSG  5
#define SYS_POLL    6
#define SYS_OPEN    7
#define SYS_CLOSE   8
#define SYS_PIPE    9
#define SYS_FCNTL   10
#define SYS_DUP     11
#define SYS_CREAT   12

#endif /* !_GREEN_IOMGR_H_ */
