/*
 * @(#)itimer_md.h	1.9 95/09/15  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/*
 * Machine or host dependent API.
 */

#ifndef _SOLARIS_ITIMER_H_
#define _SOLARIS_ITIMER_H_

#include <timeval_md.h>

/*
 *	timeval_t currentTime(): return the current time, a 64 bit
 *	    integer, in units of microseconds.
 *	unsigned int hostClockInit(): do any platform specific
 *	    initialization for the clock.  Return a monitor that the async
 *	    notification will be performed upon.
 *	void scheduleAlarm(timeval_t): schedule the alarm to occur
 *	    the indicated number of microseconds in the future.
 *	void cancelAlarm(): cancel the pending alarm (if any).
 */

timeval_t currentTime();
unsigned int hostClockInit();
void scheduleAlarm(timeval_t);
void cancelAlarm();

#endif /* !_SOLARIS_MACHAPI_H_ */
