/*
 * @(#)schedule.c	1.14 95/11/29  
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/*
 * Thread scheduling utilities and data structures.
 */

#include "sys_api.h"
#include "threads_md.h"
#include "queue.h"
#include "schedule.h"
#include "log.h"

int _scheduling_lock, _needReschedule;

queue_t runnable_queue;

void
reschedule()
{
    sys_thread_t *tid;
    extern void fullSwitchContext(context_t *);

    sysAssert(SCHED_LOCKED());
    sysAssert(_scheduling_lock == 1);
    tid = queueRemoveHead(&runnable_queue, tid);
    sysAssert(tid->state == RUNNABLE);
    Log2(5, "reschedule: from TID 0x%x to TID 0x%x\n",
    	 sysThreadSelf(), tid);
    setCurrentThread(tid);
    if (tid->full_switch) {
	fullSwitchContext(CONTEXT(tid));
    } else {
	switchContext(CONTEXT(tid));
    }
    /* NOTREACHED */
}
