/*
 * @(#)math_md.c	1.9 95/11/29
 *
 * Copyright (c) 1994 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

#include <math.h>

#include "oobj.h"
#include "interpreter.h"
#include "typecodes.h"
#include "jmath.h"

int64_t
a2ll(char * dummy)
{
    return atoll(dummy);
}

int 
matherr(struct exception *exc) 
{ 
    /* By returning a non-zero value, we prevent an error message from
     * being printed out, and errno from being set.
     */
    return 1;
}

double math_infinity;
double math_minusinfinity;
double math_minuszero;
double math_nan;

void math_init() { 
    math_infinity = HUGE_VAL;
    math_minusinfinity = -HUGE_VAL;
    math_minuszero = copysign(0.0, -1.0);
    math_nan = math_minuszero / math_minuszero;
}

