/*
 * @(#)java.c	1.11 11/13/95
 *
 * Copyright (c) 1995 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

#include <windows.h>

#include <stdio.h>
#include <stdlib.h>
#include <sys_api.h>

#ifdef JAVA_ARGS
#define NUM_ARGS (sizeof(java_args) / sizeof(char *))
char *java_args[] = JAVA_ARGS;
#else
#define NUM_ARGS 0
#endif

#ifdef DEBUG
#define JAVA "java_g"
#else
#define JAVA "java"
#endif

#ifdef WINMAIN
#define main _main
__declspec(dllimport) char **__initenv;
#endif

void
set_class_path(void)
{
    char *cp = getenv("CLASSPATH");
    char loaddir[MAX_PATH];
    char *s;

    if (cp == NULL) cp = ".";

    GetModuleFileName(NULL, loaddir, MAX_PATH);
    *(strrchr(loaddir, '\\')) = '\0';

    s = (char *)malloc(strlen(cp) + strlen(loaddir) * 2 + 64);
    sprintf(s, "CLASSPATH=%s;%s\\..\\classes;%s\\..\\lib\\classes.zip",
		cp, loaddir, loaddir);

    putenv(s);
}

int
main(int argc, char *argv[])
{
    char **newargv, **ap;
    int i;

    set_class_path();

    newargv = ap = (char **) calloc(argc + NUM_ARGS + 1, sizeof(char *));

    *ap++ = JAVA;

#ifdef JAVA_ARGS
    for (i = 0; i < NUM_ARGS; i++) {
	*ap++ = java_args[i];
    }
#endif

    for (i = 1; i < argc; i++) {
	*ap++ = argv[i];
    }

    return java_main(argc + NUM_ARGS, newargv);
}

#ifdef WINMAIN

int WINAPI
WinMain(HINSTANCE inst, HINSTANCE previnst, LPSTR cmdline, int cmdshow)
{
    int mainret;

    __initenv = _environ;
    mainret = main(__argc, __argv);
    sysExit(mainret);
}

#endif
